import h5py as h5
import numpy as np
import matplotlib.pyplot as plt
import numpy.ma as ma
import matplotlib as mpl
import seaborn as sns
from mpl_toolkits.axes_grid1.inset_locator import zoomed_inset_axes
from mpl_toolkits.axes_grid1.inset_locator import mark_inset


import scipy.spatial as spatial
import scipy.linalg as linalg
import scipy.sparse as sparse

"""
The functions here plot the figures that appear in ICCS paper.
It's assumed we already have the .h5 files required (generated by the .cpp scripts)
"""

#Latex font size is 12 pts
plt.rcParams.update({
    "mathtext.fontset": "cm",
    "font.family": "STIXGeneral",
    "text.usetex": False,
    "axes.formatter.use_mathtext": True,
    "font.size" : 12
})
plt.style.use('tableau-colorblind10')

ccycle = mpl.rcParams['axes.prop_cycle'].by_key()['color']
dpitoUse = 400

def getContent(filename):
    """Helper function to transform .h5 file into a dict"""
    
    f = h5.File(filename)
    res = {}
    for key in f.keys():
        res[key] = f[key][:]
    f.close()
    return res

def f(x,y,lap=False):
    """Return test function (sinx siny) value and derivative"""
    
    if (lap):
        return -16*np.sin(4*x)-9*np.cos(3*x)-4*np.sin(2*y)
    else:
        return 1+np.sin(4*x)+np.cos(3*x)+np.sin(2*y)


def addArrow(fig, ax1, ax2, xyA, xyB):
    """Helper function to draw an arrow between subplots"""
    
    transFigure = fig.transFigure.inverted()
    line = mpl.patches.ConnectionPatch(
        xyA,  # xdata
        xyB,  # ydata
        coordsA=ax1.transData,
        coordsB=ax2.transData,
        color="black",
        arrowstyle = "-|>",
        mutation_scale=20,
        linewidth=1,
    )
    fig.patches.append(line)


def plotSolution():
    defsize=19
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    d = getContent("Data/discretisation.h5")
    x, y = d['positions']
    z = [f(xx,yy) for xx,yy in zip(x,y)]
    fig,ax = plt.subplots()
    color = plt.get_cmap("cividis")
    sc = ax.scatter(x,y,c=z,s=0.05,cmap="cividis")
    axins = zoomed_inset_axes(ax,3,loc=1)
    axins.scatter(x,y,c=z,s=1,cmap="cividis")
    axins.set_xlim(-0.5,-0.35)
    axins.set_ylim(0.5,0.65)
    axins.set_xticks([])
    axins.set_yticks([])
    mark_inset(ax,axins,loc1=2,loc2=4)
    plt.colorbar(sc,label="$u(x,y)$")
    ax.set_aspect(1)
    ax.set_xlabel(r"$x$")
    ax.set_ylabel("$y$")
    plt.savefig("../Figures/discretisation.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')


def plotConvergence(oper):
    defsize=17
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,2,sharey=True,sharex=True,figsize=(8,4), constrained_layout=True)
    
    if oper:
        locations = [
            0.002, 0.018035733565982016,
            0.002, 0.1760720286769083,
            0.002, 0.00023750610700787166,
            0.002, 0.0009606881904451394,
            0.002, 1.859381949445566e-06,
            0.002, 3.124458829698104e-05,
            0.002, 1.5233925542163042e-08,
            0.002, 2.382734975095521e-07,
            ]
    else:
        locations = [
            0.002, 2.348697020613389e-05,
            0.002, 5.802245180381222e-05,
            0.002, 2.219635899256759e-06,
            0.002, 0.5326536678535056e-05,
            0.002, 5.0879375276766782e-10,
            0.002, 4.617469246290364e-9,
            0.003, 9.392418925440923e-11,
            0.003, 2.3990108471086635e-10,
            ]
    
    dx = []
    for m in range(2,6):
        errors = [[],[]] #L1 and Linf errors
        dx = []
        for seed in range(30):
            if oper:
                d = getContent(f"Data/solOpm{m}Seed{seed}.h5")
            else:
                d = getContent(f"Data/solm{m}Seed{seed}.h5")
            dx = d['dx']
            errors[0].append(d['error1'])
            errors[1].append(d['errorInf'])
        errors = np.array(errors)
        color = ccycle[m-2]
        for i in range(2):
            ax[i].fill_between(dx,np.amin(errors[i],axis=0),np.amax(errors[i],axis=0),color=color,alpha=0.5,label=f"$m={m}$")
            err = np.mean(errors[i],axis=0)
            k,n = np.polyfit(np.log(dx),np.log(err),1)
            rnd = str(round(k,2))
            ax[i].plot(dx,np.exp(n)*dx**k,ls="--",color=color)
            print(dx[0], err[0])
            ind = 4*(m-2)+2*i 
            ax[i].text(locations[ind],locations[ind+1],"$h^{" + rnd + "}$",color=color)
    
    ax[0].set_xscale("log")
    ax[1].set_xscale("log")
    ax[0].set_yscale("log")
    ax[0].grid()
    ax[1].grid()
    ax[0].legend(loc="right")
    ax[0].set_xlabel("$h$")
    ax[1].set_xlabel("$h$")
    if oper:
        ax[0].set_ylabel(r"$|| e_\mathrm{op} ||$")
    else:
        ax[0].set_ylabel(r"$|| e_\mathrm{sol} ||$")
    ax[0].set_title(r"$\ell_1 / N$")
    ax[1].set_title(r"$\ell_\infty$") 
    if oper:
        plt.savefig("../Figures/convergenceOp.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')
    else:
        plt.savefig("../Figures/convergence.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')


def plotConvergenceR():
    defsize=21
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,2,sharey=True,sharex=True,figsize=(8,4), constrained_layout=True)
    
    dx = []
    locations = [0.002, 3.2188408360959177e-07, 
                 0.006, 6.5112365786057657e-08,
                 0.0055, 4.512006531589026e-9,
                 0.0025, 1.1360549786355628e-11,
                 0.016, 0.7106977839113443e-11,
                 0.028, 1.910523574634711e-10,
                 0.086, 2.2751720993308132e-11,
                 0.110, 1.2154003729373624e-11]
    lines = []
    for m in range(2,6):
        errors = [[],[]] #Linf op and sol errors
        dx = []
        for seed in range(30):
            d1 = getContent(f"Data/solROpm{m}Seed{seed}.h5")
            d2 = getContent(f"Data/solRm{m}Seed{seed}.h5")
            dx = d1['R']
            errors[0].append(d1['error1'])
            errors[1].append(d2['error1'])
        errors = np.array(errors)
        color = ccycle[m-2]
        for i in range(2):
            mini = np.amin(errors[i],axis=0)
            maska = mini > 1e-11
            maxi = np.amax(errors[i],axis=0)
            lines.append(ax[i].fill_between(dx[maska],mini[maska],maxi[maska],color=color,alpha=0.5,label=f"$m={m}$"))
            err = np.median(errors[i],axis=0)[maska]
            k,n = np.polyfit(np.log(dx[maska]),np.log(err),1)
            rnd = str(round(k,2))
            ax[i].plot(dx[maska],np.exp(n)*dx[maska]**k,ls="--",color=color)
            ind = 4*(m-2)+2*i 
            ax[i].text(locations[ind],locations[ind+1],"$R^{" + rnd + "}$",color=color)
    
    ax[0].set_xscale("log")
    ax[0].set_yscale("log")
    fig.legend(lines[::2],[f"$m={m}$" for m in range(2,6)],loc=(0.5, 0.65), ncols=2, columnspacing=0.5,framealpha=1)
    ax[0].set_xlabel("$R$")
    ax[1].set_xlabel("$R$")
    ax[0].set_ylabel(r"$||e||_1$")
    ax[0].set_title("Operator error")
    ax[0].grid()
    ax[1].grid()
    ax[1].set_title(r"Solution error")    
    plt.savefig("../Figures/convergenceR.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')

def plotMatrixNorms():
    defsize=17
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,3,sharey=True,sharex=True,figsize=(8,4))
    
    for m in range(2,6):
        color = ccycle[m-2]
        norms = [[],[],[]]
        dx=None
        for seed in range(30):
            with h5.File(f"Data/matrixm{m}Seed{seed}.h5") as f:
                dx = f['dx'][:]
                for ind in range(3):
                    norms[ind].append([])
                for k in range(1,len(dx)+1):
                    if k<10:
                        i,j,val = f[f"Matrix_0000{k}"][()]
                    else:
                        i,j,val = f[f"Matrix_000{k}"][()]
                    i = (i-1).astype(int)
                    j = (j-1).astype(int)
                    mat = sparse.coo_matrix((val, (i, j)))
                    norms[0][-1].append(sparse.linalg.norm(mat,1))
                    norms[1][-1].append(sparse.linalg.norm(mat,np.inf))
                    norms[2][-1].append(sparse.linalg.norm(mat,'fro'))
        norms = np.array(norms)
        for ind in range(3):
            ax[ind].fill_between(dx,np.amin(norms[ind],axis=0),np.amax(norms[ind],axis=0),color=color,alpha=0.5,label=f"$m={m}$")
            k,n = np.polyfit(np.log(dx),np.log(np.mean(norms[ind],axis=0)),1)
            ax[ind].plot(dx,np.exp(n)*dx**k,ls="--",color=color)
            rnd = str(round(k,2))
            if m==2:
                ax[ind].text(dx[2],np.mean(norms[ind],axis=0)[2],"$h^{" + rnd + "}$",color='k')
    ax[0].set_xscale("log")
    ax[0].set_yscale("log")
    ax[0].set_title("$1$ matrix norm")
    ax[1].set_title("$\\infty$ matrix norm")
    ax[2].set_title("Frobenius matrix norm")
    ax[0].set_xlabel(r"$h$")
    ax[1].set_xlabel(r"$h$")
    ax[2].set_xlabel(r"$h$")
    ax[0].set_ylabel("Matrix norm")
    for i in range(3):
        ax[i].grid()
    ax[1].legend(loc="upper center")
    plt.savefig("../Figures/matrixNorms.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')

def plotMatrixInvNorms():
    defsize=17
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,3,sharey=True,sharex=True,figsize=(8,4))
    
    for m in range(2,6):
        color = ccycle[m-2]
        norms = [[],[],[]]
        with h5.File(f"Data/matrixCoarsem{m}Seed0.h5") as f:
            dx = f['dx'][:]
            for k in range(1,len(dx)+1):
                i,j,val = f[f"Matrix_0000{k}"][()]
                i = (i-1).astype(int)
                j = (j-1).astype(int)
                mat = sparse.coo_matrix((val, (i, j)))
                dense = mat.toarray()
                dense = linalg.inv(dense,True)
                norms[0].append(linalg.norm(dense,1))
                norms[1].append(linalg.norm(dense,np.inf))
                norms[2].append(linalg.norm(dense,'fro'))
        norms = np.array(norms)
        for ind in range(3):
            ax[ind].fill_between(dx,norms[ind],norms[ind],color=color,alpha=0.5,label=f"$m={m}$")
            k,n = np.polyfit(np.log(dx),np.log(norms[ind]),1)
            ax[ind].plot(dx,np.exp(n)*dx**k,ls="--",color=color)
            rnd = str(round(k,2))
            ax[ind].text(dx[0],norms[ind][0],"$h^{" + rnd + "}$",color=color)
    ax[0].set_xscale("log")
    ax[0].set_yscale("log")
    ax[0].set_title("$1$ matrix norm")
    ax[1].set_title("$\\infty$ matrix norm")
    ax[2].set_title("Frobenius matrix norm")
    ax[0].set_xlabel(r"$h$")
    ax[1].set_xlabel(r"$h$")
    ax[2].set_xlabel(r"$h$")
    ax[0].set_ylabel("Matrix norm")
    ax[1].legend()
    plt.savefig("../Figures/matrixInvNorms.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')

def plotErrorFormula():
    defsize=21
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,2,sharey=True,sharex=True,figsize=(8,4), constrained_layout=True)
    m=2
    dx = []
    locations = [
        0.002, 0.05604881395336072,
        0.002, 1.364542072242837e-04,
        0.002, 0.0005612488347452939,
        0.002, 2.2806131037075236e-07,
        0.002, 2.5380107289513243e-06,
        0.002, 1.3476435815730487e-9,
        ]
    for k in range(3,6):
        errors = [[],[]] #Linf op and sol errors
        dx = []
        for seed in range(30):
            d = getContent(f"Data/errorFormulam2k{k}Seed{seed}.h5")
            dx = d['dx']
            errors[0].append(d['resultLocal'])
            errors[1].append(d['result'])
        errors = np.array(errors)
        color = ccycle[k-3]
        for i in range(2):
            mini = np.amin(errors[i],axis=0)
            maxi = np.amax(errors[i],axis=0)
            ax[i].fill_between(dx,mini,maxi,color=color,alpha=0.5,label=f"$h^{k-2}$ term")
            err = np.median(errors[i],axis=0)
            kk,n = np.polyfit(np.log(dx),np.log(err),1)
            rnd = str(round(kk,2))
            ax[i].plot(dx,np.exp(n)*dx**kk,ls="--",color=color)
            ind = 4*(k-3)+2*i
            ax[i].text(locations[ind],locations[ind+1],"$h^{" + rnd + "}$",color=color)
    
    #plt.suptitle(r"Scaling of error terms, $m=2$")
    ax[0].set_xscale("log")
    ax[0].set_yscale("log")
    ax[0].legend(loc = "lower right")
    ax[0].grid()
    ax[1].grid()
    ax[0].set_xlabel("$h$")
    ax[1].set_xlabel("$h$")
    ax[0].set_ylabel(r"$||e||_1$")
    ax[0].set_title("Operator error, $m=2$")
    ax[1].set_title(r"Solution error, $m=2$")    
    plt.savefig("../Figures/errorFormula.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')
    
    
def plotAllConvergence():
    defsize=21
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    fig,ax = plt.subplots(1,2,sharey=True,sharex=True,figsize=(8,4), constrained_layout=True)
    
    locations = [[
        0.002, 0.018035733565982016,
        0.002, 0.1760720286769083,
        0.002, 0.00023750610700787166,
        0.002, 0.0009606881904451394,
        0.002, 1.859381949445566e-06,
        0.002, 3.124458829698104e-05,
        0.002, 1.5233925542163042e-08,
        0.002, 2.382734975095521e-07,
        ],[
        0.002, 2.448697020613389e-05,
        0.002, 5.802245180381222e-05,
        0.002, 5.519635899256759e-07,
        0.002, 0.5326536678535056e-05,
        0.002, 2.0879375276766782e-9,
        0.002, 4.617469246290364e-9,
        0.004, 9.392418925440923e-11,
        0.003, 2.3990108471086635e-10,
        ]]
    
    dx = []
    for m in range(2,6):
        errors = [[],[]] #L1 and Linf errors
        dx = []
        for seed in range(30):
            dOper = getContent(f"Data/solOpm{m}Seed{seed}.h5")
            dSol = getContent(f"Data/solm{m}Seed{seed}.h5")
            dx = dOper['dx']
            errors[0].append(dOper['error1'])
            errors[1].append(dSol['error1'])
        errors = np.array(errors)
        color = ccycle[m-2]
        for i in range(2):
            ax[i].fill_between(dx,np.amin(errors[i],axis=0),np.amax(errors[i],axis=0),color=color,alpha=0.5,label=f"$m={m}$")
            err = np.median(errors[i],axis=0)
            k,n = np.polyfit(np.log(dx),np.log(err),1)
            rnd = str(round(k,2))
            ax[i].plot(dx,np.exp(n)*dx**k,ls="--",color=color)
            print(dx[0], err[0])
            ind = 4*(m-2) 
            ax[i].text(locations[i][ind],locations[i][ind+1],"$h^{" + rnd + "}$",color=color)
    
    ax[0].set_xscale("log")
    ax[1].set_xscale("log")
    ax[0].set_yscale("log")
    ax[0].grid()
    ax[1].grid()
    ax[0].legend(loc="lower right")
    ax[0].set_xlabel("$h$")
    ax[1].set_xlabel("$h$")
    ax[0].set_ylabel(r"$||e||_1$")
    ax[0].set_title(r"Operator error")
    ax[1].set_title(r"Solution error") 
    plt.savefig("../Figures/convergenceAll.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')
    
    
print("Plotting the discretisation Figure...")
plotSolution()
plt.clf()

print("Plotting the convergence Figures...")
plotAllConvergence()
plt.clf()

print("Plotting the R convergence Figure..")
plotConvergenceR()
plt.clf()

print("Plotting the error formula Figure..")
plotErrorFormula()
plt.clf()

print("Done!")


    